/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqFinance (c) by 2015 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQFS_FILE_HEADER_H
#define AQFS_FILE_HEADER_H


#include <stdint.h>


typedef struct AQFS_FILE_HEADER AQFS_FILE_HEADER;


#define AQFS_FILE_HEADER_SIZE                128



AQFS_FILE_HEADER *AQFS_FileHeader_new();
void AQFS_FileHeader_free(AQFS_FILE_HEADER *fh);


int AQFS_FileHeader_ReadFromBuffer(AQFS_FILE_HEADER *fh, const uint8_t *buffer, uint64_t len);
AQFS_FILE_HEADER *AQFS_FileHeader_fromBuffer(const uint8_t *buffer, uint64_t len);
uint64_t AQFS_FileHeader_toBuffer(const AQFS_FILE_HEADER *fh, uint8_t *buffer, uint64_t len);




uint32_t AQFS_FileHeader_GetVersion(const AQFS_FILE_HEADER *fh);
void AQFS_FileHeader_SetVersion(AQFS_FILE_HEADER *fh, uint32_t i);

uint64_t AQFS_FileHeader_GetFileSize(const AQFS_FILE_HEADER *fh);
void AQFS_FileHeader_SetFileSize(AQFS_FILE_HEADER *fh, uint64_t i);






#endif
