/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqFinance (c) by 2015 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQFS_FILE_P_H
#define AQFS_FILE_P_H


#include "aqfs_file.h"

#include <aqfilestorage/aqfs_file_header.h>


#include <stdio.h>
#include <stdint.h>


#ifdef OS_WIN32
# include <windows.h>
#endif


struct AQFS_FILE {
  char *dataFileName;
  int isOpen;
  int rw;

  /* file handle */
#ifdef OS_WIN32
  HANDLE fh;
#else
  int fd;
#endif

  AQFS_FILE_HEADER *fileHeader;

  uint32_t refCount;
};



int AQFS_File_open(AQFS_FILE *fsf, int rw);
int AQFS_File_creat(AQFS_FILE *fsf);
int AQFS_File_close(AQFS_FILE *fsf);
int AQFS_File_seek(AQFS_FILE *fsf, uint64_t offs);
size_t AQFS_File_read(AQFS_FILE *fsf, uint8_t *ptr, size_t size, size_t nmember);
size_t AQFS_File_write(AQFS_FILE *fsf, const uint8_t *ptr, size_t size, size_t nmember);



int AQFS_File_ReadFileHeader(AQFS_FILE *fsf, AQFS_FILE_HEADER *fh);
int AQFS_File_WriteFileHeader(AQFS_FILE *fsf, const AQFS_FILE_HEADER *fh);


int AQFS_File_WriteTable(AQFS_FILE *fsf, AQFS_TABLE *ft);


#endif
